/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * BresenhamApplet.java
 *
 * Created on 24.10.2010, 17:11:11
 */

package bresenhamapplet;

import java.awt.event.ItemEvent;

/**
 *
 * @author Sunshine2k
 */
public class BresenhamApplet extends javax.swing.JApplet implements BresenhamEventListener {

    /**
     * Specifies the total width of the applet
     */
    public static final int APPLET_WIDTH        = 640;
    /**
     * Specifies the total height of the applet
     */
    public static final int APPELT_HEIGHT       = 400;

    /**
     * The x-coordinate of panel position
     */
    public static final int DRAWPANEL_X         = 10;
    /**
     * The y-coordinate of panel position
     */
    public static final int DRAWPANEL_Y         = 10;
    /**
     * width of drawing panel
     */
    public static final int DRAWPANEL_WIDTH     = 32 * 12;
    /**
     * height of drawing panel
     */
    public static final int DRAWPANEL_HEIGHT    = 32 * 12;

    private BresenhamPanel drawingPanel;

    /** Initializes the applet BresenhamApplet */
    @Override
    public void init() {
        try {
            java.awt.EventQueue.invokeAndWait(new Runnable() {
                public void run() {
                    initComponents();
                }
            });
        } catch (Exception ex) {
            ex.printStackTrace();
        }

        this.setLayout(null);
        this.setSize(APPLET_WIDTH, APPELT_HEIGHT);

        drawingPanel = new BresenhamPanel(DRAWPANEL_WIDTH, DRAWPANEL_HEIGHT);
        drawingPanel.setBounds(DRAWPANEL_X, DRAWPANEL_Y, DRAWPANEL_WIDTH, DRAWPANEL_HEIGHT);
        this.getContentPane().add(drawingPanel);

        // init view combobox items
        for (int i = 4; i <= 64; i <<= 1)
            this.ViewComboboxZoom.addItem(i+ "x");
        ViewComboboxZoom.setEnabled(true);
        ViewRadioButtonNormal.setSelected(true);
        ViewRadioButtonZoomed.setSelected(false);
        ViewComboboxZoom.setSelectedIndex(0);
        drawingPanel.setZoomMode(1);

        RadioButtonDrawLineDDA.setForeground(BresenhamPanel.LineColorDDA);
        RadioButtonDrawLineBHFloat.setForeground(BresenhamPanel.LineColorBHFloat);
        RadioButtonDrawLineBHInt.setForeground(BresenhamPanel.LineColorBHInt);

        RadioButtonDrawCircleSimple1.setForeground(BresenhamPanel.CircleColorSimpleBad);
        RadioButtonDrawCircleSimple2.setForeground(BresenhamPanel.CircleColorSimpleGood);
        RadioButtonDrawCircleBHFloat.setForeground(BresenhamPanel.CircleColorBHFloat);
        RadioButtonDrawCircleBHInt.setForeground(BresenhamPanel.CircleColorBHInt);

        DrawRadioButtonLine.setSelected(true);
        RadioButtonDrawLineDDA.setSelected(true);
        RadioButtonDrawCircleSimple2.setSelected(true);

        drawingPanel.addBresenhamEventListener(this);
    }

    private void setZoomMode(String zoomStr)
    {
        if (zoomStr.equals("1x"))
            drawingPanel.setZoomMode(1);
        else if (zoomStr.equals("2x"))
            drawingPanel.setZoomMode(2);
        else if (zoomStr.equals("4x"))
            drawingPanel.setZoomMode(4);
        else if (zoomStr.equals("8x"))
            drawingPanel.setZoomMode(8);
        else if (zoomStr.equals("16x"))
            drawingPanel.setZoomMode(16);
        else if (zoomStr.equals("32x"))
            drawingPanel.setZoomMode(32);
        else if (zoomStr.equals("64x"))
            drawingPanel.setZoomMode(64);
        else
        {
            /* should not happen */
        }
    }

    /**
     * Called if mouse position on bresenham panel is changed
     * @param bpe reference to mouse event
     */
    public void BresenhamEvent(BresenhamPaneMouselEvent bpe) {
        PosLabelX.setText("X = " + bpe.mouseTileX);
        PosLabelY.setText("Y = " + bpe.mouseTileY);
    }
    

    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        ViewButtonGroup = new javax.swing.ButtonGroup();
        DrawPrimitiveButtonGroup = new javax.swing.ButtonGroup();
        LineModeButtonGroup = new javax.swing.ButtonGroup();
        CircleModeButtonGroup = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        ViewComboboxZoom = new javax.swing.JComboBox();
        ViewRadioButtonNormal = new javax.swing.JRadioButton();
        ViewRadioButtonZoomed = new javax.swing.JRadioButton();
        jPanel2 = new javax.swing.JPanel();
        DrawRadioButtonLine = new javax.swing.JRadioButton();
        RadioButtonDrawLineDDA = new javax.swing.JRadioButton();
        RadioButtonDrawLineBHFloat = new javax.swing.JRadioButton();
        RadioButtonDrawLineBHInt = new javax.swing.JRadioButton();
        DrawRadioButtonCircle = new javax.swing.JRadioButton();
        RadioButtonDrawCircleSimple1 = new javax.swing.JRadioButton();
        RadioButtonDrawCircleSimple2 = new javax.swing.JRadioButton();
        RadioButtonDrawCircleBHFloat = new javax.swing.JRadioButton();
        RadioButtonDrawCircleBHInt = new javax.swing.JRadioButton();
        DrawRadioButtonEllipse = new javax.swing.JRadioButton();
        jPanel3 = new javax.swing.JPanel();
        PosLabelX = new javax.swing.JLabel();
        PosLabelY = new javax.swing.JLabel();

        getContentPane().setLayout(null);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("View"));
        jPanel1.setLayout(null);

        ViewComboboxZoom.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        ViewComboboxZoom.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                ViewComboboxZoomItemStateChanged(evt);
            }
        });
        jPanel1.add(ViewComboboxZoom);
        ViewComboboxZoom.setBounds(110, 60, 100, 19);

        ViewButtonGroup.add(ViewRadioButtonNormal);
        ViewRadioButtonNormal.setFont(new java.awt.Font("Tahoma", 0, 10));
        ViewRadioButtonNormal.setSelected(true);
        ViewRadioButtonNormal.setText("Normal Mode");
        ViewRadioButtonNormal.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                ViewRadioButtonNormalItemStateChanged(evt);
            }
        });
        jPanel1.add(ViewRadioButtonNormal);
        ViewRadioButtonNormal.setBounds(10, 20, 85, 21);

        ViewButtonGroup.add(ViewRadioButtonZoomed);
        ViewRadioButtonZoomed.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        ViewRadioButtonZoomed.setText("Zoomed Mode");
        ViewRadioButtonZoomed.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                ViewRadioButtonZoomedItemStateChanged(evt);
            }
        });
        jPanel1.add(ViewRadioButtonZoomed);
        ViewRadioButtonZoomed.setBounds(10, 60, 91, 21);

        getContentPane().add(jPanel1);
        jPanel1.setBounds(400, 0, 240, 100);

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Drawing Algorithm"));
        jPanel2.setLayout(null);

        DrawPrimitiveButtonGroup.add(DrawRadioButtonLine);
        DrawRadioButtonLine.setFont(new java.awt.Font("Tahoma", 1, 10)); // NOI18N
        DrawRadioButtonLine.setText("LINE");
        DrawRadioButtonLine.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                DrawRadioButtonLineItemStateChanged(evt);
            }
        });
        jPanel2.add(DrawRadioButtonLine);
        DrawRadioButtonLine.setBounds(10, 30, 49, 21);

        LineModeButtonGroup.add(RadioButtonDrawLineDDA);
        RadioButtonDrawLineDDA.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        RadioButtonDrawLineDDA.setText("DDA");
        RadioButtonDrawLineDDA.setToolTipText("Digital Differential Analyzer");
        RadioButtonDrawLineDDA.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                RadioButtonDrawLineDDAItemStateChanged(evt);
            }
        });
        jPanel2.add(RadioButtonDrawLineDDA);
        RadioButtonDrawLineDDA.setBounds(110, 30, 47, 21);

        LineModeButtonGroup.add(RadioButtonDrawLineBHFloat);
        RadioButtonDrawLineBHFloat.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        RadioButtonDrawLineBHFloat.setText("Bresenham (Float)");
        RadioButtonDrawLineBHFloat.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                RadioButtonDrawLineBHFloatItemStateChanged(evt);
            }
        });
        jPanel2.add(RadioButtonDrawLineBHFloat);
        RadioButtonDrawLineBHFloat.setBounds(110, 50, 110, 21);

        LineModeButtonGroup.add(RadioButtonDrawLineBHInt);
        RadioButtonDrawLineBHInt.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        RadioButtonDrawLineBHInt.setText("Bresenham (Int)");
        RadioButtonDrawLineBHInt.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                RadioButtonDrawLineBHIntItemStateChanged(evt);
            }
        });
        jPanel2.add(RadioButtonDrawLineBHInt);
        RadioButtonDrawLineBHInt.setBounds(110, 70, 110, 21);

        DrawPrimitiveButtonGroup.add(DrawRadioButtonCircle);
        DrawRadioButtonCircle.setFont(new java.awt.Font("Tahoma", 1, 10)); // NOI18N
        DrawRadioButtonCircle.setText("CIRCLE");
        DrawRadioButtonCircle.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                DrawRadioButtonCircleItemStateChanged(evt);
            }
        });
        jPanel2.add(DrawRadioButtonCircle);
        DrawRadioButtonCircle.setBounds(10, 120, 70, 21);

        CircleModeButtonGroup.add(RadioButtonDrawCircleSimple1);
        RadioButtonDrawCircleSimple1.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        RadioButtonDrawCircleSimple1.setText("Simple (bad)");
        RadioButtonDrawCircleSimple1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                RadioButtonDrawCircleSimple1ItemStateChanged(evt);
            }
        });
        jPanel2.add(RadioButtonDrawCircleSimple1);
        RadioButtonDrawCircleSimple1.setBounds(110, 120, 83, 21);

        CircleModeButtonGroup.add(RadioButtonDrawCircleSimple2);
        RadioButtonDrawCircleSimple2.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        RadioButtonDrawCircleSimple2.setText("Simple (Good)");
        RadioButtonDrawCircleSimple2.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                RadioButtonDrawCircleSimple2ItemStateChanged(evt);
            }
        });
        jPanel2.add(RadioButtonDrawCircleSimple2);
        RadioButtonDrawCircleSimple2.setBounds(110, 140, 91, 21);

        CircleModeButtonGroup.add(RadioButtonDrawCircleBHFloat);
        RadioButtonDrawCircleBHFloat.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        RadioButtonDrawCircleBHFloat.setText("Bresenham (Float)");
        RadioButtonDrawCircleBHFloat.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                RadioButtonDrawCircleBHFloatItemStateChanged(evt);
            }
        });
        jPanel2.add(RadioButtonDrawCircleBHFloat);
        RadioButtonDrawCircleBHFloat.setBounds(110, 160, 107, 21);

        CircleModeButtonGroup.add(RadioButtonDrawCircleBHInt);
        RadioButtonDrawCircleBHInt.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        RadioButtonDrawCircleBHInt.setText("Bresenham (Int)");
        RadioButtonDrawCircleBHInt.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                RadioButtonDrawCircleBHIntItemStateChanged(evt);
            }
        });
        jPanel2.add(RadioButtonDrawCircleBHInt);
        RadioButtonDrawCircleBHInt.setBounds(110, 180, 100, 21);

        DrawPrimitiveButtonGroup.add(DrawRadioButtonEllipse);
        DrawRadioButtonEllipse.setFont(new java.awt.Font("Tahoma", 1, 10)); // NOI18N
        DrawRadioButtonEllipse.setText("ELLIPSE");
        DrawRadioButtonEllipse.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                DrawRadioButtonEllipseItemStateChanged(evt);
            }
        });
        jPanel2.add(DrawRadioButtonEllipse);
        DrawRadioButtonEllipse.setBounds(10, 210, 80, 21);

        getContentPane().add(jPanel2);
        jPanel2.setBounds(400, 100, 240, 240);

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Mouse Position"));
        jPanel3.setLayout(null);

        PosLabelX.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        PosLabelX.setText("X = ");
        jPanel3.add(PosLabelX);
        PosLabelX.setBounds(20, 30, 80, 13);

        PosLabelY.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        PosLabelY.setText("Y =");
        jPanel3.add(PosLabelY);
        PosLabelY.setBounds(120, 30, 50, 13);

        getContentPane().add(jPanel3);
        jPanel3.setBounds(400, 340, 240, 60);
    }// </editor-fold>//GEN-END:initComponents

    private void ViewRadioButtonNormalItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_ViewRadioButtonNormalItemStateChanged
        if (evt.getStateChange() == ItemEvent.SELECTED)
        {
            drawingPanel.setZoomMode(1);
            ViewComboboxZoom.setEnabled(false);
        }
    }//GEN-LAST:event_ViewRadioButtonNormalItemStateChanged

    private void ViewRadioButtonZoomedItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_ViewRadioButtonZoomedItemStateChanged
        if (evt.getStateChange() == ItemEvent.SELECTED)
        {
            setZoomMode(ViewComboboxZoom.getSelectedItem().toString());
            ViewComboboxZoom.setEnabled(true);
        }
    }//GEN-LAST:event_ViewRadioButtonZoomedItemStateChanged

    private void ViewComboboxZoomItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_ViewComboboxZoomItemStateChanged
        if (evt.getStateChange() == ItemEvent.SELECTED)
        {
            setZoomMode(evt.getItem().toString());
        }
    }//GEN-LAST:event_ViewComboboxZoomItemStateChanged

    private void RadioButtonDrawLineDDAItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_RadioButtonDrawLineDDAItemStateChanged
        if (evt.getStateChange() == ItemEvent.SELECTED)
        {
            drawingPanel.setLineDrawingMode(BresenhamPanel.LineDrawingMode.DDA);
        }
    }//GEN-LAST:event_RadioButtonDrawLineDDAItemStateChanged

    private void RadioButtonDrawLineBHFloatItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_RadioButtonDrawLineBHFloatItemStateChanged
        if (evt.getStateChange() == ItemEvent.SELECTED)
        {
            drawingPanel.setLineDrawingMode(BresenhamPanel.LineDrawingMode.BRESENHAMFLOAT);
        }
    }//GEN-LAST:event_RadioButtonDrawLineBHFloatItemStateChanged

    private void RadioButtonDrawLineBHIntItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_RadioButtonDrawLineBHIntItemStateChanged
        if (evt.getStateChange() == ItemEvent.SELECTED)
        {
            drawingPanel.setLineDrawingMode(BresenhamPanel.LineDrawingMode.BRESENHAMINT);
        }
    }//GEN-LAST:event_RadioButtonDrawLineBHIntItemStateChanged

    private void DrawRadioButtonLineItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_DrawRadioButtonLineItemStateChanged
        RadioButtonDrawCircleSimple1.setEnabled(false);
        RadioButtonDrawCircleSimple2.setEnabled(false);
        RadioButtonDrawCircleBHInt.setEnabled(false);
        RadioButtonDrawCircleBHFloat.setEnabled(false);
        RadioButtonDrawLineDDA.setEnabled(true);
        RadioButtonDrawLineBHFloat.setEnabled(true);
        RadioButtonDrawLineBHInt.setEnabled(true);
        // notify bresenham panel
        drawingPanel.setPrimitiveMode(BresenhamPanel.PrimitiveMode.LINE);
    }//GEN-LAST:event_DrawRadioButtonLineItemStateChanged

    private void RadioButtonDrawCircleBHIntItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_RadioButtonDrawCircleBHIntItemStateChanged
        if (evt.getStateChange() == ItemEvent.SELECTED) {
            drawingPanel.setCircleDrawingMode(BresenhamPanel.CircleDrawingMode.BRESENHAMINT);
        }
}//GEN-LAST:event_RadioButtonDrawCircleBHIntItemStateChanged

    private void RadioButtonDrawCircleBHFloatItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_RadioButtonDrawCircleBHFloatItemStateChanged
        if (evt.getStateChange() == ItemEvent.SELECTED) {
            drawingPanel.setCircleDrawingMode(BresenhamPanel.CircleDrawingMode.BRESENHAMFLOAT);
        }
}//GEN-LAST:event_RadioButtonDrawCircleBHFloatItemStateChanged

    private void RadioButtonDrawCircleSimple2ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_RadioButtonDrawCircleSimple2ItemStateChanged
        if (evt.getStateChange() == ItemEvent.SELECTED) {
            drawingPanel.setCircleDrawingMode(BresenhamPanel.CircleDrawingMode.SIMPLEGOOD);
        }
}//GEN-LAST:event_RadioButtonDrawCircleSimple2ItemStateChanged

    private void RadioButtonDrawCircleSimple1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_RadioButtonDrawCircleSimple1ItemStateChanged
        if (evt.getStateChange() == ItemEvent.SELECTED) {
            drawingPanel.setCircleDrawingMode(BresenhamPanel.CircleDrawingMode.SIMPLEBAD);
        }
}//GEN-LAST:event_RadioButtonDrawCircleSimple1ItemStateChanged

    private void DrawRadioButtonCircleItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_DrawRadioButtonCircleItemStateChanged
        RadioButtonDrawCircleSimple1.setEnabled(true);
        RadioButtonDrawCircleSimple2.setEnabled(true);
        RadioButtonDrawCircleBHInt.setEnabled(true);
        RadioButtonDrawCircleBHFloat.setEnabled(true);
        RadioButtonDrawLineDDA.setEnabled(false);
        RadioButtonDrawLineBHFloat.setEnabled(false);
        RadioButtonDrawLineBHInt.setEnabled(false);
        // notify bresenham panel
        drawingPanel.setPrimitiveMode(BresenhamPanel.PrimitiveMode.CIRCLE);
}//GEN-LAST:event_DrawRadioButtonCircleItemStateChanged

    private void DrawRadioButtonEllipseItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_DrawRadioButtonEllipseItemStateChanged
        RadioButtonDrawCircleSimple1.setEnabled(false);
        RadioButtonDrawCircleSimple2.setEnabled(false);
        RadioButtonDrawCircleBHInt.setEnabled(false);
        RadioButtonDrawCircleBHFloat.setEnabled(false);
        RadioButtonDrawLineDDA.setEnabled(false);
        RadioButtonDrawLineBHFloat.setEnabled(false);
        RadioButtonDrawLineBHInt.setEnabled(false);
        // notify bresenham panel
        drawingPanel.setPrimitiveMode(BresenhamPanel.PrimitiveMode.ELLIPSE);
    }//GEN-LAST:event_DrawRadioButtonEllipseItemStateChanged


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup CircleModeButtonGroup;
    private javax.swing.ButtonGroup DrawPrimitiveButtonGroup;
    private javax.swing.JRadioButton DrawRadioButtonCircle;
    private javax.swing.JRadioButton DrawRadioButtonEllipse;
    private javax.swing.JRadioButton DrawRadioButtonLine;
    private javax.swing.ButtonGroup LineModeButtonGroup;
    private javax.swing.JLabel PosLabelX;
    private javax.swing.JLabel PosLabelY;
    private javax.swing.JRadioButton RadioButtonDrawCircleBHFloat;
    private javax.swing.JRadioButton RadioButtonDrawCircleBHInt;
    private javax.swing.JRadioButton RadioButtonDrawCircleSimple1;
    private javax.swing.JRadioButton RadioButtonDrawCircleSimple2;
    private javax.swing.JRadioButton RadioButtonDrawLineBHFloat;
    private javax.swing.JRadioButton RadioButtonDrawLineBHInt;
    private javax.swing.JRadioButton RadioButtonDrawLineDDA;
    private javax.swing.ButtonGroup ViewButtonGroup;
    private javax.swing.JComboBox ViewComboboxZoom;
    private javax.swing.JRadioButton ViewRadioButtonNormal;
    private javax.swing.JRadioButton ViewRadioButtonZoomed;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    // End of variables declaration//GEN-END:variables



}
